---
title: XRPose
slug: Web/API/XRPose
tags:
  - 3DoF
  - 6DoF
  - API
  - AR
  - Interface
  - NeedsExample
  - Orientation
  - Position
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRPose
  - augmented
  - pose
  - space
  - transform
---
<p>{{APIRef("WebXR Device API")}}{{securecontext_header}}{{draft}}</p>

<p><span class="seoSummary"><code>XRPose</code> is a <a href="/en-US/docs/Web/API/WebXR_API">WebXR API</a> interface representing a position and orientation in the 3D space, relative to the {{domxref("XRSpace")}} within which it resides.</span> The <code>XRSpace</code>—which is either an {{domxref("XRReferenceSpace")}} or an {{domxref("XRBoundedReferenceSpace")}}—defines the coordinate system used for the pose and, in the case of an {{domxref("XRViewerPose")}}, its underlying views.</p>

<p>To obtain the <code>XRPose</code> for the <code>XRSpace</code> used as the local coordinate system of an object, call {{domxref("XRFrame.getPose()")}}, specifying that local <code>XRSpace</code> and the space to which you wish to convert:</p>

<pre class="brush: js">thePose = xrFrame.getPose(localSpace, baseSpace);</pre>

<p>The pose for a viewer (or camera) is represented by the {{domxref("XRViewerPose")}} subclass of <code>XRPose</code>. This is obtained using {{domxref("XRFrame.getViewerPose()")}}  instead of <code>getPose()</code>, specifying a reference space which has been adjusted to position and orient the node to provide the desired viewing position and angle:</p>

<pre class="brush: js">viewerPose = xrFrame.getViewerPose(adjReferenceSpace);</pre>

<p>Here, <code>adjReferenceSpace</code> is a reference space which has been updated using the base frame of reference for the frame and any adjustments needed to position the viewer based on movement or rotation which is being supplied from a source other than the XR device, such as keyboard or mouse inputs<strong>.</strong></p>

<p>See the article <a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a> for further details and an example with thorough explanations of what's going on.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{DOMxRef("XRPose.transform")}} {{readonlyInline}}</dt>
 <dd>A {{DOMxRef("XRRigidTransform")}} which provides the position and orientation of the pose relative to the base {{DOMxRef("XRSpace")}}.</dd>
 <dt>{{DOMxRef("XRPose.emulatedPosition")}} {{readonlyInline}}</dt>
 <dd>A Boolean value which is <code>false</code> if the position and orientation given by {{DOMxRef("XRPose.transform", "transform")}} is obtained directly from a full six degree of freedom (6DoF) XR device (that is, a device which tracks not only the pitch, yaw, and roll of the head but also the forward, backward, and side-to-side motion of the viewer). If any component of the <code>transform</code> is computed or created artificially (such as by using mouse or keyboard controls to move through space), this value is instead <code>true</code>, indicating that the <code>transform</code> is in part emulated in software.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrpose-interface","XRPose")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRPose")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li>{{DOMxRef("XRFrame.getPose()")}}</li>
 <li>{{DOMxRef("XRViewerPose")}}</li>
</ul>
